<?xml version="1.0"?>
<xsl:transform version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:doj="http://www.doj.state.wi.us/dles/cib/internal/dnrv/response"          
  xmlns:dnrv-ext="http://www.doj.state.wi.us/dles/cib/internal/dnrv/response/extension"
  xmlns:doj-ext="http://www.doj.state.wi.us/dles/cib/extension"
  xmlns:j="http://www.it.ojp.gov/jxdm/3.0.2">
  
  <xsl:param name="readOnly"/>
  <xsl:template name="DenialReversalResponse">
    <!-- Format header information -->
    <h2 class="filetype">
      <xsl:text>Denied / Reversed Requests :</xsl:text>
    </h2>
    <hr/>
    <xsl:call-template name="RequestData"/>
    <!--   <xsl:apply-templates select="doj:RecordIdentifiers"/>
   <xsl:apply-templates select="doj:BuyerInformation"/>
    <xsl:apply-templates select="doj:AdditionalInformation"/> -->
  </xsl:template>
  
  <xsl:template name="RequestData">
    <table class="dataTable" width="100%">
      <thead>
        <tr>           
          <!--          
     <th>Date of Birth</th>
          <th>Sex</th>
          <th>Race</th>   --> 
          <th width="10%">Request ID</th> 
 <!--     <th width="20%">ID Type</th>   -->
          <th>Name</th>
          <th width="10%">ID No.</th>     
   <!--   <th>Form ID</th>
          <th>Confirmation ID</th>  -->
          <th width="10%">Dealer ID</th>
          <th width="10%">Request Date</th>
          <th width="10%">Status</th>
          <th width="30%">Comments/Description</th>
        </tr>
      </thead>
      <tbody>
        <xsl:apply-templates select="//doj:DenialReversalResponse"/>
      </tbody>
    </table>
  </xsl:template>
  
  <xsl:template match="doj:DenialReversalResponse">
    <tr align="center">
      <td><xsl:value-of select="doj:RecordIdentifiers/dnrv-ext:RequestID/j:ID"/></td>
      <td>
        <xsl:value-of select="doj:BuyerInformation/j:PersonName/j:PersonSurName"/>,
        <xsl:value-of select="doj:BuyerInformation/j:PersonName/j:PersonGivenName"/>
        <xsl:text> </xsl:text>
        <xsl:value-of select="doj:BuyerInformation/j:PersonName/j:PersonMiddleName"/>
      </td>
 <!--     <td>
        <xsl:call-template name="YYYY-MM-DD_to_MM-DD-YYYY">
          <xsl:with-param name="YYYY-MM-DD" select="doj:BuyerInformation/j:PersonBirthDate" />
        </xsl:call-template>
      </td>
 <td>
        <xsl:call-template name="resolveSexCode">
          <xsl:with-param name="sexCode" select="doj:BuyerInformation/j:PersonPhysicalDetails/j:PersonSexCode" />
        </xsl:call-template>
      </td>  
      <td>
        <xsl:call-template name="RaceCode">
          <xsl:with-param name="raceCode" select="doj:BuyerInformation/j:PersonPhysicalDetails/j:PersonRaceCode" />
        </xsl:call-template>
      </td>  
      <td>
        <xsl:call-template name="photoidCode">
          <xsl:with-param name="idCode" select="doj:BuyerInformation/j:PersonAssignedIDDetails/j:PersonOtherID/j:IDTypeText" />
        </xsl:call-template>
      </td>   -->
      <td><xsl:value-of select="doj:BuyerInformation/j:PersonAssignedIDDetails/j:PersonOtherID/j:ID"/></td>
<!--      <td><xsl:value-of select="doj:RecordIdentifiers/dnrv-ext:FormID/j:ID"/></td>
      <td><xsl:value-of select="doj:RecordIdentifiers/dnrv-ext:ConfirmationID/j:ID"/></td>    -->
      <td><xsl:value-of select="doj:AdditionalInformation/dnrv-ext:DealerID/j:ID"/></td>
      <td>
        <xsl:call-template name="YYYY-MM-DD_to_MM-DD-YYYY">
          <xsl:with-param name="YYYY-MM-DD" select="doj:AdditionalInformation/dnrv-ext:RequestDate" />
        </xsl:call-template>
      </td>
      <td><xsl:value-of select="doj:AdditionalInformation/dnrv-ext:ResultTypeCode"/></td>
      <td align="justify"><xsl:value-of select="doj:AdditionalInformation/dnrv-ext:ResultCodeDesc"/></td>
    </tr>
  </xsl:template>
  
  
  <xsl:template match="doj:RequestID">
    <xsl:text>Purchase Request ID:</xsl:text>
  </xsl:template>
 
  <xsl:template name="DateValue">
    <xsl:param name="date"/>
    <xsl:value-of select='substring($date,1,10)'/>
  </xsl:template> 
  
  <xsl:template name="resolveSexCode">
    <xsl:param name="sexCode"/>
    <xsl:choose>
      <xsl:when test="$sexCode='F'">
        <xsl:text>Female</xsl:text>
      </xsl:when>
      <xsl:when test="$sexCode='M'">
        <xsl:text>Male</xsl:text>
      </xsl:when>
      <xsl:when test="$sexCode='U'">
        <xsl:text>Unknown</xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$sexCode"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  
  <xsl:template name="RaceCode">
    <xsl:param name="raceCode"/>
    <xsl:choose>
      <xsl:when test="$raceCode='W'">
        <xsl:text>White</xsl:text>
      </xsl:when>
      <xsl:when test="$raceCode='B'">
        <xsl:text>Black</xsl:text>
      </xsl:when>
      <xsl:when test="$raceCode='A'">
        <xsl:text>Asian or Pacific Islander</xsl:text>
      </xsl:when>
      <xsl:when test="$raceCode='I'">
        <xsl:text>American Indian or Alaskan Native</xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:text>Unknown</xsl:text>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  
  
  <xsl:template name="YYYY-MM-DD_to_MM-DD-YYYY">
    <xsl:param name="YYYY-MM-DD"/>
    <xsl:value-of select="substring($YYYY-MM-DD, 6, 2)"/>
    <xsl:text>/</xsl:text>
    <xsl:value-of select="substring($YYYY-MM-DD, 9, 2)"/>
    <xsl:text>/</xsl:text>
    <xsl:value-of select="substring($YYYY-MM-DD, 1, 4)"/>
  </xsl:template>
  
  <xsl:template name="photoidCode">
    <xsl:param name="idCode"/>
    <xsl:choose>
      <xsl:when test="$idCode='WL'">
        <xsl:text>Wisconsin Driver License</xsl:text>
      </xsl:when>
      <xsl:when test="$idCode='WD'">
        <xsl:text>Wisconsin ID Card</xsl:text>
      </xsl:when>
      <xsl:when test="$idCode='OI'">
        <xsl:text>Out of State ID Card</xsl:text>
      </xsl:when>
      <xsl:when test="$idCode='OL'">
        <xsl:text>Out of State Driver License</xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$idCode"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  
  </xsl:transform>
  
